/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
*/

import { ServiceClientOptions, RequestOptions, ServiceCallback } from 'ms-rest';
import * as models from '../models';


/**
 * @class
 * LROs
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestLongRunningOperationTestService.
 */
export interface LROs {

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Succeeded’.
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put200Succeeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    put200Succeeded(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Succeeded’.
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPut200Succeeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPut200Succeeded(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that does not contain ProvisioningState=’Succeeded’.
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put200SucceededNoState(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    put200SucceededNoState(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that does not contain ProvisioningState=’Succeeded’.
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPut200SucceededNoState(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPut200SucceededNoState(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 202 to the initial request,
     * with a location header that points to a polling URL that returns a 200 and
     * an entity that doesn't contains ProvisioningState
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put202Retry200(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    put202Retry200(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 202 to the initial request,
     * with a location header that points to a polling URL that returns a 200 and
     * an entity that doesn't contains ProvisioningState
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPut202Retry200(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPut202Retry200(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 201 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’.  Polls return
     * this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Succeeded’
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put201CreatingSucceeded200(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    put201CreatingSucceeded200(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 201 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’.  Polls return
     * this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Succeeded’
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPut201CreatingSucceeded200(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPut201CreatingSucceeded200(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 201 to the initial request,
     * with an entity that contains ProvisioningState=’Updating’.  Polls return
     * this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Succeeded’
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put200UpdatingSucceeded204(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    put200UpdatingSucceeded204(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 201 to the initial request,
     * with an entity that contains ProvisioningState=’Updating’.  Polls return
     * this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Succeeded’
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPut200UpdatingSucceeded204(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPut200UpdatingSucceeded204(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 201 to the initial request,
     * with an entity that contains ProvisioningState=’Created’.  Polls return
     * this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Failed’
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put201CreatingFailed200(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    put201CreatingFailed200(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 201 to the initial request,
     * with an entity that contains ProvisioningState=’Created’.  Polls return
     * this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Failed’
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPut201CreatingFailed200(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPut201CreatingFailed200(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 201 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’.  Polls return
     * this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Canceled’
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put200Acceptedcanceled200(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    put200Acceptedcanceled200(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 201 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’.  Polls return
     * this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Canceled’
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPut200Acceptedcanceled200(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPut200Acceptedcanceled200(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 202 to the initial request with
     * location header. Subsequent calls to operation status do not contain
     * location header.
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putNoHeaderInRetry(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    putNoHeaderInRetry(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 202 to the initial request with
     * location header. Subsequent calls to operation status do not contain
     * location header.
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutNoHeaderInRetry(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPutNoHeaderInRetry(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putAsyncRetrySucceeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    putAsyncRetrySucceeded(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutAsyncRetrySucceeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPutAsyncRetrySucceeded(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putAsyncNoRetrySucceeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    putAsyncNoRetrySucceeded(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutAsyncNoRetrySucceeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPutAsyncNoRetrySucceeded(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putAsyncRetryFailed(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    putAsyncRetryFailed(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutAsyncRetryFailed(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPutAsyncRetryFailed(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putAsyncNoRetrycanceled(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    putAsyncNoRetrycanceled(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutAsyncNoRetrycanceled(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPutAsyncNoRetrycanceled(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 202 to the initial request with
     * Azure-AsyncOperation header. Subsequent calls to operation status do not
     * contain Azure-AsyncOperation header.
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putAsyncNoHeaderInRetry(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    putAsyncNoHeaderInRetry(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 202 to the initial request with
     * Azure-AsyncOperation header. Subsequent calls to operation status do not
     * contain Azure-AsyncOperation header.
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutAsyncNoHeaderInRetry(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPutAsyncNoHeaderInRetry(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request with non resource.
     *
     * @param {object} [sku] sku to put
     * 
     * @param {string} [sku.name]
     * 
     * @param {string} [sku.id]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putNonResource(sku: models.Sku, options: RequestOptions, callback: ServiceCallback<models.Sku>): void;
    putNonResource(sku: models.Sku, callback: ServiceCallback<models.Sku>): void;

    /**
     * Long running put request with non resource.
     *
     * @param {object} [sku] sku to put
     * 
     * @param {string} [sku.name]
     * 
     * @param {string} [sku.id]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutNonResource(sku: models.Sku, options: RequestOptions, callback: ServiceCallback<models.Sku>): void;
    beginPutNonResource(sku: models.Sku, callback: ServiceCallback<models.Sku>): void;

    /**
     * Long running put request with non resource.
     *
     * @param {object} [sku] Sku to put
     * 
     * @param {string} [sku.name]
     * 
     * @param {string} [sku.id]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putAsyncNonResource(sku: models.Sku, options: RequestOptions, callback: ServiceCallback<models.Sku>): void;
    putAsyncNonResource(sku: models.Sku, callback: ServiceCallback<models.Sku>): void;

    /**
     * Long running put request with non resource.
     *
     * @param {object} [sku] Sku to put
     * 
     * @param {string} [sku.name]
     * 
     * @param {string} [sku.id]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutAsyncNonResource(sku: models.Sku, options: RequestOptions, callback: ServiceCallback<models.Sku>): void;
    beginPutAsyncNonResource(sku: models.Sku, callback: ServiceCallback<models.Sku>): void;

    /**
     * Long running put request with sub resource.
     *
     * @param {object} [product] Sub Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putSubResource(product: models.SubProduct, options: RequestOptions, callback: ServiceCallback<models.SubProduct>): void;
    putSubResource(product: models.SubProduct, callback: ServiceCallback<models.SubProduct>): void;

    /**
     * Long running put request with sub resource.
     *
     * @param {object} [product] Sub Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutSubResource(product: models.SubProduct, options: RequestOptions, callback: ServiceCallback<models.SubProduct>): void;
    beginPutSubResource(product: models.SubProduct, callback: ServiceCallback<models.SubProduct>): void;

    /**
     * Long running put request with sub resource.
     *
     * @param {object} [product] Sub Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putAsyncSubResource(product: models.SubProduct, options: RequestOptions, callback: ServiceCallback<models.SubProduct>): void;
    putAsyncSubResource(product: models.SubProduct, callback: ServiceCallback<models.SubProduct>): void;

    /**
     * Long running put request with sub resource.
     *
     * @param {object} [product] Sub Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutAsyncSubResource(product: models.SubProduct, options: RequestOptions, callback: ServiceCallback<models.SubProduct>): void;
    beginPutAsyncSubResource(product: models.SubProduct, callback: ServiceCallback<models.SubProduct>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Accepted’.  Polls return
     * this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Succeeded’
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    deleteProvisioning202Accepted200Succeeded(options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    deleteProvisioning202Accepted200Succeeded(callback: ServiceCallback<models.Product>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Accepted’.  Polls return
     * this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Succeeded’
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDeleteProvisioning202Accepted200Succeeded(options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginDeleteProvisioning202Accepted200Succeeded(callback: ServiceCallback<models.Product>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’.  Polls return
     * this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Failed’
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    deleteProvisioning202DeletingFailed200(options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    deleteProvisioning202DeletingFailed200(callback: ServiceCallback<models.Product>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’.  Polls return
     * this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Failed’
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDeleteProvisioning202DeletingFailed200(options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginDeleteProvisioning202DeletingFailed200(callback: ServiceCallback<models.Product>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’.  Polls return
     * this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Canceled’
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    deleteProvisioning202Deletingcanceled200(options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    deleteProvisioning202Deletingcanceled200(callback: ServiceCallback<models.Product>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’.  Polls return
     * this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Canceled’
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDeleteProvisioning202Deletingcanceled200(options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginDeleteProvisioning202Deletingcanceled200(callback: ServiceCallback<models.Product>): void;

    /**
     * Long running delete succeeds and returns right away
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    delete204Succeeded(options: RequestOptions, callback: ServiceCallback<void>): void;
    delete204Succeeded(callback: ServiceCallback<void>): void;

    /**
     * Long running delete succeeds and returns right away
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDelete204Succeeded(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDelete204Succeeded(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Polls return this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Succeeded’
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    delete202Retry200(options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    delete202Retry200(callback: ServiceCallback<models.Product>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Polls return this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Succeeded’
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDelete202Retry200(options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginDelete202Retry200(callback: ServiceCallback<models.Product>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Polls return this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Succeeded’
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    delete202NoRetry204(options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    delete202NoRetry204(callback: ServiceCallback<models.Product>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Polls return this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Succeeded’
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDelete202NoRetry204(options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginDelete202NoRetry204(callback: ServiceCallback<models.Product>): void;

    /**
     * Long running delete request, service returns a location header in the
     * initial request. Subsequent calls to operation status do not contain
     * location header.
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    deleteNoHeaderInRetry(options: RequestOptions, callback: ServiceCallback<void>): void;
    deleteNoHeaderInRetry(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a location header in the
     * initial request. Subsequent calls to operation status do not contain
     * location header.
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDeleteNoHeaderInRetry(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDeleteNoHeaderInRetry(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns an Azure-AsyncOperation header
     * in the initial request. Subsequent calls to operation status do not
     * contain Azure-AsyncOperation header.
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    deleteAsyncNoHeaderInRetry(options: RequestOptions, callback: ServiceCallback<void>): void;
    deleteAsyncNoHeaderInRetry(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns an Azure-AsyncOperation header
     * in the initial request. Subsequent calls to operation status do not
     * contain Azure-AsyncOperation header.
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDeleteAsyncNoHeaderInRetry(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDeleteAsyncNoHeaderInRetry(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Poll the endpoint indicated in the Azure-AsyncOperation header for
     * operation status
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    deleteAsyncRetrySucceeded(options: RequestOptions, callback: ServiceCallback<void>): void;
    deleteAsyncRetrySucceeded(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Poll the endpoint indicated in the Azure-AsyncOperation header for
     * operation status
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDeleteAsyncRetrySucceeded(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDeleteAsyncRetrySucceeded(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Poll the endpoint indicated in the Azure-AsyncOperation header for
     * operation status
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    deleteAsyncNoRetrySucceeded(options: RequestOptions, callback: ServiceCallback<void>): void;
    deleteAsyncNoRetrySucceeded(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Poll the endpoint indicated in the Azure-AsyncOperation header for
     * operation status
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDeleteAsyncNoRetrySucceeded(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDeleteAsyncNoRetrySucceeded(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Poll the endpoint indicated in the Azure-AsyncOperation header for
     * operation status
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    deleteAsyncRetryFailed(options: RequestOptions, callback: ServiceCallback<void>): void;
    deleteAsyncRetryFailed(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Poll the endpoint indicated in the Azure-AsyncOperation header for
     * operation status
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDeleteAsyncRetryFailed(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDeleteAsyncRetryFailed(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Poll the endpoint indicated in the Azure-AsyncOperation header for
     * operation status
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    deleteAsyncRetrycanceled(options: RequestOptions, callback: ServiceCallback<void>): void;
    deleteAsyncRetrycanceled(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Poll the endpoint indicated in the Azure-AsyncOperation header for
     * operation status
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDeleteAsyncRetrycanceled(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDeleteAsyncRetrycanceled(callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with 'Location' header. Poll returns a 200 with a response body after
     * success.
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post200WithPayload(options: RequestOptions, callback: ServiceCallback<models.Sku>): void;
    post200WithPayload(callback: ServiceCallback<models.Sku>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with 'Location' header. Poll returns a 200 with a response body after
     * success.
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPost200WithPayload(options: RequestOptions, callback: ServiceCallback<models.Sku>): void;
    beginPost200WithPayload(callback: ServiceCallback<models.Sku>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with 'Location' and 'Retry-After' headers, Polls return a 200 with a
     * response body after success
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post202Retry200(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    post202Retry200(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with 'Location' and 'Retry-After' headers, Polls return a 200 with a
     * response body after success
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPost202Retry200(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    beginPost202Retry200(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with 'Location' header, 204 with noresponse body after success
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post202NoRetry204(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    post202NoRetry204(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with 'Location' header, 204 with noresponse body after success
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPost202NoRetry204(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPost202NoRetry204(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postAsyncRetrySucceeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    postAsyncRetrySucceeded(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPostAsyncRetrySucceeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPostAsyncRetrySucceeded(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postAsyncNoRetrySucceeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    postAsyncNoRetrySucceeded(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPostAsyncNoRetrySucceeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPostAsyncNoRetrySucceeded(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postAsyncRetryFailed(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    postAsyncRetryFailed(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPostAsyncRetryFailed(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    beginPostAsyncRetryFailed(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postAsyncRetrycanceled(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    postAsyncRetrycanceled(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPostAsyncRetrycanceled(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    beginPostAsyncRetrycanceled(product: models.Product, callback: ServiceCallback<void>): void;
}

/**
 * @class
 * LRORetrys
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestLongRunningOperationTestService.
 */
export interface LRORetrys {

    /**
     * Long running put request, service returns a 500, then a 201 to the initial
     * request, with an entity that contains ProvisioningState=’Creating’.  Polls
     * return this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Succeeded’
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put201CreatingSucceeded200(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    put201CreatingSucceeded200(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 500, then a 201 to the initial
     * request, with an entity that contains ProvisioningState=’Creating’.  Polls
     * return this value until the last poll returns a ‘200’ with
     * ProvisioningState=’Succeeded’
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPut201CreatingSucceeded200(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPut201CreatingSucceeded200(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 500, then a 200 to the initial
     * request, with an entity that contains ProvisioningState=’Creating’. Poll
     * the endpoint indicated in the Azure-AsyncOperation header for operation
     * status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putAsyncRelativeRetrySucceeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    putAsyncRelativeRetrySucceeded(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 500, then a 200 to the initial
     * request, with an entity that contains ProvisioningState=’Creating’. Poll
     * the endpoint indicated in the Azure-AsyncOperation header for operation
     * status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutAsyncRelativeRetrySucceeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPutAsyncRelativeRetrySucceeded(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running delete request, service returns a 500, then a  202 to the
     * initial request, with an entity that contains
     * ProvisioningState=’Accepted’.  Polls return this value until the last poll
     * returns a ‘200’ with ProvisioningState=’Succeeded’
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    deleteProvisioning202Accepted200Succeeded(options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    deleteProvisioning202Accepted200Succeeded(callback: ServiceCallback<models.Product>): void;

    /**
     * Long running delete request, service returns a 500, then a  202 to the
     * initial request, with an entity that contains
     * ProvisioningState=’Accepted’.  Polls return this value until the last poll
     * returns a ‘200’ with ProvisioningState=’Succeeded’
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDeleteProvisioning202Accepted200Succeeded(options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginDeleteProvisioning202Accepted200Succeeded(callback: ServiceCallback<models.Product>): void;

    /**
     * Long running delete request, service returns a 500, then a 202 to the
     * initial request. Polls return this value until the last poll returns a
     * ‘200’ with ProvisioningState=’Succeeded’
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    delete202Retry200(options: RequestOptions, callback: ServiceCallback<void>): void;
    delete202Retry200(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 500, then a 202 to the
     * initial request. Polls return this value until the last poll returns a
     * ‘200’ with ProvisioningState=’Succeeded’
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDelete202Retry200(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDelete202Retry200(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 500, then a 202 to the
     * initial request. Poll the endpoint indicated in the Azure-AsyncOperation
     * header for operation status
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    deleteAsyncRelativeRetrySucceeded(options: RequestOptions, callback: ServiceCallback<void>): void;
    deleteAsyncRelativeRetrySucceeded(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 500, then a 202 to the
     * initial request. Poll the endpoint indicated in the Azure-AsyncOperation
     * header for operation status
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDeleteAsyncRelativeRetrySucceeded(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDeleteAsyncRelativeRetrySucceeded(callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 500, then a 202 to the initial
     * request, with 'Location' and 'Retry-After' headers, Polls return a 200
     * with a response body after success
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post202Retry200(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    post202Retry200(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 500, then a 202 to the initial
     * request, with 'Location' and 'Retry-After' headers, Polls return a 200
     * with a response body after success
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPost202Retry200(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    beginPost202Retry200(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 500, then a 202 to the initial
     * request, with an entity that contains ProvisioningState=’Creating’. Poll
     * the endpoint indicated in the Azure-AsyncOperation header for operation
     * status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postAsyncRelativeRetrySucceeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    postAsyncRelativeRetrySucceeded(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 500, then a 202 to the initial
     * request, with an entity that contains ProvisioningState=’Creating’. Poll
     * the endpoint indicated in the Azure-AsyncOperation header for operation
     * status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPostAsyncRelativeRetrySucceeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    beginPostAsyncRelativeRetrySucceeded(product: models.Product, callback: ServiceCallback<void>): void;
}

/**
 * @class
 * LROSADs
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestLongRunningOperationTestService.
 */
export interface LROSADs {

    /**
     * Long running put request, service returns a 400 to the initial request
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putNonRetry400(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    putNonRetry400(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 400 to the initial request
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutNonRetry400(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPutNonRetry400(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a Product with
     * 'ProvisioningState' = 'Creating' and 201 response code
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putNonRetry201Creating400(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    putNonRetry201Creating400(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a Product with
     * 'ProvisioningState' = 'Creating' and 201 response code
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutNonRetry201Creating400(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPutNonRetry201Creating400(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 with
     * ProvisioningState=’Creating’. Poll the endpoint indicated in the
     * Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putAsyncRelativeRetry400(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    putAsyncRelativeRetry400(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 with
     * ProvisioningState=’Creating’. Poll the endpoint indicated in the
     * Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutAsyncRelativeRetry400(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPutAsyncRelativeRetry400(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running delete request, service returns a 400 with an error body
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    deleteNonRetry400(options: RequestOptions, callback: ServiceCallback<void>): void;
    deleteNonRetry400(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 400 with an error body
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDeleteNonRetry400(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDeleteNonRetry400(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 with a location header
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    delete202NonRetry400(options: RequestOptions, callback: ServiceCallback<void>): void;
    delete202NonRetry400(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 with a location header
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDelete202NonRetry400(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDelete202NonRetry400(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Poll the endpoint indicated in the Azure-AsyncOperation header for
     * operation status
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    deleteAsyncRelativeRetry400(options: RequestOptions, callback: ServiceCallback<void>): void;
    deleteAsyncRelativeRetry400(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Poll the endpoint indicated in the Azure-AsyncOperation header for
     * operation status
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDeleteAsyncRelativeRetry400(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDeleteAsyncRelativeRetry400(callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 400 with no error body
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postNonRetry400(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    postNonRetry400(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 400 with no error body
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPostNonRetry400(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    beginPostNonRetry400(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 with a location header
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post202NonRetry400(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    post202NonRetry400(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 with a location header
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPost202NonRetry400(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    beginPost202NonRetry400(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request
     * Poll the endpoint indicated in the Azure-AsyncOperation header for
     * operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postAsyncRelativeRetry400(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    postAsyncRelativeRetry400(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request
     * Poll the endpoint indicated in the Azure-AsyncOperation header for
     * operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPostAsyncRelativeRetry400(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    beginPostAsyncRelativeRetry400(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running put request, service returns a 201 to the initial request with
     * no payload
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putError201NoProvisioningStatePayload(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    putError201NoProvisioningStatePayload(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 201 to the initial request with
     * no payload
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutError201NoProvisioningStatePayload(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPutError201NoProvisioningStatePayload(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putAsyncRelativeRetryNoStatus(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    putAsyncRelativeRetryNoStatus(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutAsyncRelativeRetryNoStatus(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPutAsyncRelativeRetryNoStatus(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putAsyncRelativeRetryNoStatusPayload(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    putAsyncRelativeRetryNoStatusPayload(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutAsyncRelativeRetryNoStatusPayload(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPutAsyncRelativeRetryNoStatusPayload(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running delete request, service returns a 204 to the initial request,
     * indicating success.
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    delete204Succeeded(options: RequestOptions, callback: ServiceCallback<void>): void;
    delete204Succeeded(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 204 to the initial request,
     * indicating success.
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDelete204Succeeded(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDelete204Succeeded(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Poll the endpoint indicated in the Azure-AsyncOperation header for
     * operation status
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    deleteAsyncRelativeRetryNoStatus(options: RequestOptions, callback: ServiceCallback<void>): void;
    deleteAsyncRelativeRetryNoStatus(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Poll the endpoint indicated in the Azure-AsyncOperation header for
     * operation status
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDeleteAsyncRelativeRetryNoStatus(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDeleteAsyncRelativeRetryNoStatus(callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * without a location header.
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post202NoLocation(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    post202NoLocation(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * without a location header.
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPost202NoLocation(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    beginPost202NoLocation(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postAsyncRelativeRetryNoPayload(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    postAsyncRelativeRetryNoPayload(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPostAsyncRelativeRetryNoPayload(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    beginPostAsyncRelativeRetryNoPayload(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that is not a valid json
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put200InvalidJson(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    put200InvalidJson(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that is not a valid json
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPut200InvalidJson(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPut200InvalidJson(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. The endpoint
     * indicated in the Azure-AsyncOperation header is invalid.
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putAsyncRelativeRetryInvalidHeader(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    putAsyncRelativeRetryInvalidHeader(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. The endpoint
     * indicated in the Azure-AsyncOperation header is invalid.
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutAsyncRelativeRetryInvalidHeader(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPutAsyncRelativeRetryInvalidHeader(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putAsyncRelativeRetryInvalidJsonPolling(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    putAsyncRelativeRetryInvalidJsonPolling(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running put request, service returns a 200 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutAsyncRelativeRetryInvalidJsonPolling(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPutAsyncRelativeRetryInvalidJsonPolling(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request
     * receing a reponse with an invalid 'Location' and 'Retry-After' headers
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    delete202RetryInvalidHeader(options: RequestOptions, callback: ServiceCallback<void>): void;
    delete202RetryInvalidHeader(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request
     * receing a reponse with an invalid 'Location' and 'Retry-After' headers
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDelete202RetryInvalidHeader(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDelete202RetryInvalidHeader(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * The endpoint indicated in the Azure-AsyncOperation header is invalid
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    deleteAsyncRelativeRetryInvalidHeader(options: RequestOptions, callback: ServiceCallback<void>): void;
    deleteAsyncRelativeRetryInvalidHeader(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * The endpoint indicated in the Azure-AsyncOperation header is invalid
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDeleteAsyncRelativeRetryInvalidHeader(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDeleteAsyncRelativeRetryInvalidHeader(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Poll the endpoint indicated in the Azure-AsyncOperation header for
     * operation status
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    deleteAsyncRelativeRetryInvalidJsonPolling(options: RequestOptions, callback: ServiceCallback<void>): void;
    deleteAsyncRelativeRetryInvalidJsonPolling(callback: ServiceCallback<void>): void;

    /**
     * Long running delete request, service returns a 202 to the initial request.
     * Poll the endpoint indicated in the Azure-AsyncOperation header for
     * operation status
     *
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginDeleteAsyncRelativeRetryInvalidJsonPolling(options: RequestOptions, callback: ServiceCallback<void>): void;
    beginDeleteAsyncRelativeRetryInvalidJsonPolling(callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with invalid 'Location' and 'Retry-After' headers.
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post202RetryInvalidHeader(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    post202RetryInvalidHeader(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with invalid 'Location' and 'Retry-After' headers.
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPost202RetryInvalidHeader(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    beginPost202RetryInvalidHeader(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. The endpoint
     * indicated in the Azure-AsyncOperation header is invalid.
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postAsyncRelativeRetryInvalidHeader(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    postAsyncRelativeRetryInvalidHeader(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. The endpoint
     * indicated in the Azure-AsyncOperation header is invalid.
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPostAsyncRelativeRetryInvalidHeader(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    beginPostAsyncRelativeRetryInvalidHeader(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postAsyncRelativeRetryInvalidJsonPolling(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    postAsyncRelativeRetryInvalidJsonPolling(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * Long running post request, service returns a 202 to the initial request,
     * with an entity that contains ProvisioningState=’Creating’. Poll the
     * endpoint indicated in the Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPostAsyncRelativeRetryInvalidJsonPolling(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    beginPostAsyncRelativeRetryInvalidJsonPolling(product: models.Product, callback: ServiceCallback<void>): void;
}

/**
 * @class
 * LROsCustomHeader
 * __NOTE__: An instance of this class is automatically created for an
 * instance of the AutoRestLongRunningOperationTestService.
 */
export interface LROsCustomHeader {

    /**
     * x-ms-client-request-id = 9C4D50EE-2D56-4CD3-8152-34347DC9F2B0 is required
     * message header for all requests. Long running put request, service returns
     * a 200 to the initial request, with an entity that contains
     * ProvisioningState=’Creating’. Poll the endpoint indicated in the
     * Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    putAsyncRetrySucceeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    putAsyncRetrySucceeded(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * x-ms-client-request-id = 9C4D50EE-2D56-4CD3-8152-34347DC9F2B0 is required
     * message header for all requests. Long running put request, service returns
     * a 200 to the initial request, with an entity that contains
     * ProvisioningState=’Creating’. Poll the endpoint indicated in the
     * Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPutAsyncRetrySucceeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPutAsyncRetrySucceeded(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * x-ms-client-request-id = 9C4D50EE-2D56-4CD3-8152-34347DC9F2B0 is required
     * message header for all requests. Long running put request, service returns
     * a 201 to the initial request, with an entity that contains
     * ProvisioningState=’Creating’.  Polls return this value until the last poll
     * returns a ‘200’ with ProvisioningState=’Succeeded’
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    put201CreatingSucceeded200(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    put201CreatingSucceeded200(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * x-ms-client-request-id = 9C4D50EE-2D56-4CD3-8152-34347DC9F2B0 is required
     * message header for all requests. Long running put request, service returns
     * a 201 to the initial request, with an entity that contains
     * ProvisioningState=’Creating’.  Polls return this value until the last poll
     * returns a ‘200’ with ProvisioningState=’Succeeded’
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPut201CreatingSucceeded200(product: models.Product, options: RequestOptions, callback: ServiceCallback<models.Product>): void;
    beginPut201CreatingSucceeded200(product: models.Product, callback: ServiceCallback<models.Product>): void;

    /**
     * x-ms-client-request-id = 9C4D50EE-2D56-4CD3-8152-34347DC9F2B0 is required
     * message header for all requests. Long running post request, service
     * returns a 202 to the initial request, with 'Location' and 'Retry-After'
     * headers, Polls return a 200 with a response body after success
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    post202Retry200(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    post202Retry200(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * x-ms-client-request-id = 9C4D50EE-2D56-4CD3-8152-34347DC9F2B0 is required
     * message header for all requests. Long running post request, service
     * returns a 202 to the initial request, with 'Location' and 'Retry-After'
     * headers, Polls return a 200 with a response body after success
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPost202Retry200(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    beginPost202Retry200(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * x-ms-client-request-id = 9C4D50EE-2D56-4CD3-8152-34347DC9F2B0 is required
     * message header for all requests. Long running post request, service
     * returns a 202 to the initial request, with an entity that contains
     * ProvisioningState=’Creating’. Poll the endpoint indicated in the
     * Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    postAsyncRetrySucceeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    postAsyncRetrySucceeded(product: models.Product, callback: ServiceCallback<void>): void;

    /**
     * x-ms-client-request-id = 9C4D50EE-2D56-4CD3-8152-34347DC9F2B0 is required
     * message header for all requests. Long running post request, service
     * returns a 202 to the initial request, with an entity that contains
     * ProvisioningState=’Creating’. Poll the endpoint indicated in the
     * Azure-AsyncOperation header for operation status
     *
     * @param {object} [product] Product to put
     * 
     * @param {string} [product.provisioningState]
     * 
     * @param {object} [product.tags]
     * 
     * @param {string} [product.location] Resource Location
     * 
     * @param {object} [options]
     *
     * @param {object} [options.customHeaders] headers that will be added to
     * request
     *
     * @param {ServiceCallback} [callback] callback function; see ServiceCallback
     * doc in ms-rest index.d.ts for details
     */
    beginPostAsyncRetrySucceeded(product: models.Product, options: RequestOptions, callback: ServiceCallback<void>): void;
    beginPostAsyncRetrySucceeded(product: models.Product, callback: ServiceCallback<void>): void;
}
